﻿using System;
using System.Collections.Generic;
using System.Linq;
using System;
using System.Diagnostics;
using System.Threading;
using System.Drawing;
using System.Text;
using System;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.TreeSharp;
using Styx.Helpers;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.Pathing;
using Styx.Plugins;


namespace GroupGreet
{
    public partial class GroupGreeter : HBPlugin
    {
        public override string Name { get { return "GroupGreeter"; } }
        public override string Author { get { return "wownerds"; } }
        public override Version Version { get { return new Version(0, 0, 2, 1); } }
        public override string ButtonText { get { return "Config"; } }
        private static LocalPlayer Me { get { return StyxWoW.Me; } }

        public override bool WantButton
        {
            get
            {
                return true;
            }
        }
        public override void OnButtonPress()
        {
            GroupGreet.GroupGreeterCFG cfg = new GroupGreet.GroupGreeterCFG();
            cfg.ShowDialog();
        }

        public bool gg_enable;
        public bool greetedyet;

        public override void Initialize()
        {
            GroupGreeterSettings.Instance.Load();
            greetedyet = false;
            Logging.Write("[GroupGreet]: GroupGreeter loaded up.");
            if (GroupGreeterSettings.Instance.gg_enable == false)
            {
                Logging.Write("[GroupGreet]: GroupGreeter is currently DISABLED!");
            }
            else
            {
                Logging.Write("[GroupGreet]: GroupGreeter is currently ENABLED!");
                Logging.Write("[GroupGreet]: Your greeting text is: \"" + GroupGreeterSettings.Instance.greeting.ToString() + "\"!");
            }
            Logging.WriteDiagnostic("[DIAG_GroupGreet]: greeted? " + greetedyet.ToString());
            Pulse();
        }


        public override void Pulse()
        {
            if (!Me.GroupInfo.IsInParty && !Me.GroupInfo.IsInLfgParty && !Me.GroupInfo.IsInRaid)
            {
                greetedyet = false;
                Logging.WriteDiagnostic("[DIAG_GroupGreet]: greeted? " + greetedyet.ToString());
            }
            Greet();
        }

        private void Greet()
        {
            if (GroupGreeterSettings.Instance.gg_enable == true && GroupGreeterSettings.Instance.greeting.Length > 0 && greetedyet == false && (Me.GroupInfo.IsInParty || Me.GroupInfo.IsInLfgParty || Me.GroupInfo.IsInRaid))
            {
                Styx.Common.Logging.Write("[GroupGreet]: You joined a new group!");
                Styx.WoWInternals.Lua.DoString("SendChatMessage(\"" + GroupGreeterSettings.Instance.greeting.ToString() + "\", \"INSTANCE_CHAT\", \"nil\", \"INSTANCE_CHAT\");");
                Logging.WriteDiagnostic("[DIAG_GroupGreet]: SendChatMessage(\"" + GroupGreeterSettings.Instance.greeting.ToString() + "\", \"INSTANCE_CHAT\", \"nil\", \"INSTANCE_CHAT\")");
                Styx.Common.Logging.Write("[GroupGreet]: Your level " + Me.Level.ToString() + " " + Me.Class.ToString() + " greeted your group saying: \"" + GroupGreeterSettings.Instance.greeting.ToString() + "\"!");
                greetedyet = true;
                Logging.WriteDiagnostic("[DIAG_GroupGreet]: greeted? " + greetedyet.ToString());
            }
        }
    }
}
