﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Styx;
using Styx.Helpers;
using Styx.Common;

namespace GroupGreet
{
    public class GroupGreeterSettings : Settings
    {
        public static readonly GroupGreeterSettings Instance = new GroupGreeterSettings();

        public GroupGreeterSettings()
            : base(System.IO.Path.Combine(Styx.Common.Utilities.AssemblyDirectory, "Settings", string.Format(@"GG-{0}-{1}.xml", StyxWoW.Me.Name, StyxWoW.Me.RealmName)))
        {
        }

        [Setting, DefaultValue(true)]
        public bool gg_enable { get; set; }

        [Setting, DefaultValue("hi")]
        public string greeting { get; set; }
    }
}
